
/* This code is copyright (c) 2000, John Hansen, W2FS.  It is not public domain
nor is it shareware.  Licensed amateur radio operators are hereby permitted to 
burn one copy of this code for their own personal use.  Note: permission is 
explicitly NOT granted for you to burn chips containing this code for others.
For information on obtaining the commercial rights to this code contact the 
author at john@hansen.net
*/ 



int txdel;


void getstring(char * s,int max) {
   int len;
   char c;

   max--;
   len=0;
   do {
     c=getc();
  //   c= toupper(c);
     if(c==8) {  // Backspace
        if(len>0) {
          len--;
          putc(c);
          putc(' ');
          putc(c);
        }
     } else if ((c>=' ')&&(c<='~'))
       if(len<max) {
         s[len++]=c;
         putc(c);
       }
   } while(c!=13);
   s[len]=0;
}

nl(){
    putc(0x0d);putc(0x0a);
}

Settxdel(){

int msec;
char txdy[3];

    txdel = read_eeprom(0);
    if (txdel > 149) (txdel = 40);
    msec = (txdel*2)/3;

    txdy[0] = (msec/10)+48;
    txdy[1] = (msec%10)+48;
    nl();nl();nl();nl();
    printf("Current TXDelay = ");putc(txdy[0]);putc(txdy[1]);nl();
    printf("Enter New Value (02 - 80): ");
    getstring(txdy,3);nl();
    printf("TXDelay Now :");putc(txdy[0]);putc(txdy[1]);
    nl();nl();nl();
    
    msec = ((txdy[0]-48)*10 ) + (txdy[1]-48);
    if (msec < 100){
        txdel = (msec*3)/2;
        write_eeprom(0,txdel);
    }

}
SetOpMode(){
int opmode;
short stop;
    
    opmode = read_eeprom(1);

    nl();nl();
    printf("Current OpMode is: ");putc(opmode);nl();nl();
    printf("Enter New OpMode: 1. Kiss Mode.");nl();
    printf("                  2. APRS Mode.");nl();nl();
    printf("Selection: ");
    opmode = 0;
    stop = FALSE;
    do{
        opmode = getc();
        if ((opmode> 0x30) & (opmode<0x33)) {
            putc(opmode);nl();nl();
            stop = TRUE;
        }
    }while (stop == FALSE);
    printf("New Opmode is: ");putc(opmode);nl();nl();
    write_eeprom(1,opmode);
}

void putcall(int cnum){
int i, select;

    for(i=0;i<6;i++){        //read the callsign from the eeprom
        select = read_eeprom(cnum+i);   
        select = select >> 1;   //right shift each byte
        if (select != 0x20) (putc(select));  
    }
    select = read_eeprom(cnum+6);
    select = select>>1;
    if (select != 0x30){
       if (select > 0x39) (select = select +7);
       putc('-');
       putc(select);
    }
    nl();
    
}
void getcall(int cnum){  //get callsign (i is offset in eeprom)
char callsign[7];
int i, ssid;

    printf("Enter New Callsign: ");
    for (i=0;i<6;i++)(callsign[i]= 0x00);
    getstring(callsign,7);
    for(i=0;i<6;i++){
        callsign[i] = toupper(callsign[i]);
        if (callsign[i] == 0x00) (callsign[i] = 0x20); //pad end with spaces
        callsign[i] = callsign[i] << 1;
        write_eeprom(cnum + i,callsign[i]);
    }
    nl();
    printf("Enter New SSID (0 to F) :");
    ssid = getc();putc(ssid);nl();nl();
    if (ssid > 0x39) (ssid = ssid-7);
    ssid = ssid<<1;
    write_eeprom(cnum+6,ssid);
    if (read_eeprom(9) == 0x40){   //check to see if path1 is null, if so set last callsign1 bit to 1
            i = read_eeprom(8);
            i++;
            write_eeprom(8,i);
    }
    else if (read_eeprom(16) == 0x40){ //same for path2
            i = read_eeprom(15);
            i++;
            write_eeprom(15,i);
    }
    else if (read_eeprom(23) == 0x40){ //same for path3
            i = read_eeprom(22);
            i++;
            write_eeprom(22,i);
    }
    else {
            i = read_eeprom(29);
            i++;
            write_eeprom(29,i);
    }
}
readicon(){

int tendig,onedig, num;
    
    num = read_eeprom(30);
    tendig = (num>>4) + 0x30;
    if (tendig > 0x39) (tendig = tendig+7);
    onedig = (num & 0x0F) + 0x30;
    if (onedig > 0x39) (onedig = onedig+7);
    putc(tendig);putc(onedig);
    nl();



}

writeicon(){
int digone, digten;
char value[3];
 
        getstring(value,3);
        value[0] = value[0] - 0x30;
        if (value[0] > 9) (value[0] = value[0] -7); //handles hex digits
        value[1] = value[1] - 0x30;
        if (value[1] > 9) (value[1] = value[1] -7); 
        write_eeprom(30, (value[0]*16)+value[1]);
}

read2dec(int loc) {

int tendig,onedig, num;

    num = read_eeprom(loc);
    tendig = num/10 + 0x30;
    if (tendig > 0x39) (tendig = tendig+7);
    onedig = num%10 + 0x30;
    if (onedig > 0x39) (onedig = onedig+7);
    putc(tendig);putc(onedig);
    nl();
}

write2dec(loc) {
int digone, digten,num;
char value[3];
 
        getstring(value,3);
        value[0] = value[0] - 0x30;
        if (value[0] > 9) (value[0] = value[0] -7); //handles hex digits
        value[1] = value[1] - 0x30;
        if (value[1] > 9) (value[1] = value[1] -7); 
        write_eeprom(loc, (value[0]*10)+value[1]);
}

writebeacon(){
char value[41];
int i;
    for (i = 0;i<40;i++) (value[i] = 0);
    i = 0;
    getstring(value,41);
    while (i< 41){
        write_eeprom(36+i,value[i]);
        i++;
    }
}

readbeacon(){
int i,beac;

    i=0;
    while (read_eeprom(i+36) != 0){
        putc(read_eeprom(i+36));
        i++;
    }
}

Writeicontab(){
int answer;
short done;
    done = FALSE;
    do{
        answer = toupper(getc());
        if ((answer == 0x59) | (answer == 0x4E)){
             putc(answer);
             write_eeprom(31,answer);
             done = TRUE;
        }
    }while (done == FALSE);
}

Messnum(){
int num;
short done;

    done = FALSE;
    do {
        num = getc();
        if ((num < 0x38) & (num>= 0x30)){
            putc(num);
            num = ((num - 0x30) ^ 0b111);  //invert the message bit pattern
	   
            write_eeprom(35,num);
            done = TRUE;
        }
    }while(done == FALSE);
}

SetAprs(){
int select,value;

    select = 0x00;    
    do {
        nl();nl();
        printf("         Current APRS Parameters");nl();nl();

        Printf("1. Station Callsign: ");putcall(2);
        printf("2. First Path Callsign: ");putcall(9);
        printf("3. Second Path Callsign: ");putcall(16);
        printf("4. Third Path Callsign: ");putcall(23);
        printf("5. Icon Number: ");readicon();
        printf("6. Alt. Icon Table? (Y/N): ");putc(read_eeprom(31));nl();
        printf("7. Delay Between Xmit (x 10 secs): ");read2dec(32);
        printf("8. Quiet Time (in secs): ");read2dec(34);
        printf("9. Message Number: ");putc((read_eeprom(35)+0x30)^0b111);nl();
        printf("A. Set Beacon Rate: ");read2dec(33);nl();
        printf("B. Beacon Text: ");readbeacon();nl();nl();
        
        printf("Select Parameter to Change: ");select = toupper(getc());putc(select);nl();
        switch (select){

            case 0x31: getcall(2);break;
            case 0x32: getcall(9);break;
            case 0x33: getcall(16);break;
            case 0x34: getcall(23);break;
            case 0x35: printf("Enter Icon #: ");writeicon();break;
            case 0x36: printf("Alt. Icon Table? (Y/N): ");writeicontab();break;
            case 0x37: printf("Enter Delay: ");write2dec(32);break;
            case 0x38: printf("Enter Quiet Time: ");write2dec(34); break;
            case 0x39: printf("Enter Message Number (0-7): ");messnum();break;
            case 0x41: printf("Enter Beacon Rate : ");write2dec(33);break;
            case 0x42: printf("Enter New Beacon Text: ");writebeacon();
        }
    }while (select != 0x0D);
    
 
}
eraseall(){
int i;

write_eeprom(0,0x26);
write_eeprom(1,0x31);
for (i=2;i<8;i++) (write_eeprom(i,0x40));
write_eeprom(8,0x60);
for (i=9;i<15;i++) (write_eeprom(i,0x40));
write_eeprom(15,0x60);
for (i=16;i<22;i++) (write_eeprom(i,0x40));
write_eeprom(22,0x60);
for (i=23;i<29;i++) (write_eeprom(i,0x40));
write_eeprom(29,0x60);
write_eeprom(30,0x3E);
write_eeprom(31,'N');
write_eeprom(32,0);
write_eeprom(33,3);
write_eeprom(34,0);
write_eeprom(35,1);
for (i=36;i<80;i++) (write_eeprom(i,0x00));
write_eeprom(0x80,0x01);
}

SetBaud(){
int command;
        nl();nl();
        
        printf("       1. 1200 Baud.");nl();
        printf("       2. 2400 Baud.");nl();
        printf("       3. 4800 Baud.");nl();
        printf("       4. 9600 Baud.");nl();
        printf("       5. 19200 Baud.");nl();nl();
        printf("Current Baudrate is: ");putc(read_eeprom(80));nl();
        printf("Selection: ");
        command = getc();putc(command);
        write_eeprom(80,command);nl();nl();
}     

Terminal(){
int command;

    While (TRUE){

        printf("        Configuration Menu");nl();nl();
        printf("        1. Operating Mode.");nl();
        printf("        2. Set TXDelay.");nl();
        printf("        3. Set Terminal Baud Rate.");nl();
        printf("        4. Set APRS Parameters.");nl();nl();
        printf("        E. Erase All Parameters.");nl();nl();
       

        printf(" Selection: ");
        command = getc();
        switch(command){
            case 0x31:   SetOpMode();break;
            case 0x32:   Settxdel();break;
            case 0x33:   SetBaud();break;
            case 0x34:   SetAprs();break;
            case 0x45:   Eraseall();break;
            case 0x65:   Eraseall();
        }
   }          

}

